%define major 1
%define libname %mklibname ming %{major}
%define devname %mklibname ming -d

%define oname libming
%define oversion 0_4_8

Summary:	Ming - an SWF output library
Name:		ming
Version:	0.4.8
Release:	2
Epoch:		2
License:	LGPLv2+
Group:		System/Libraries
Url:		https://www.libming.org/
Source0:	https://github.com/libming/libming/archive/%{oname}-%{name}-%{oversion}.tar.gz
Patch0:		ming-automake-1.13.patch
Patch1:		ming-0.4.8-01-Fix-CVS-2017-8782.patch
Patch2:		ming-0.4.8-02-Fix-CVE-2017-8782.patch
Patch3:		ming-0.4.8-03-Fix-CVE-2017-11704.patch
Patch4:		ming-0.4.8-04-Fix-CVE-2017-11728_to_11730.patch
Patch5:		ming-0.4.8-05-Fix-CVE-2017-11734.patch
Patch6:		ming-0.4.8-06-Fix-CVE-2017-9988.patch
Patch7:		ming-0.4.8-07-Fix-CVE-2017-9989.patch
Patch8:		ming-0.4.8-08-Avoid-NULL-pointer-deref.patch
Patch9:		ming-0.4.8-09-Fix-CVE-2017-11733.patch
Patch10:	ming-0.4.8-10-Fix-various-read-methods.patch
Patch11:	ming-0.4.8-11-Remove-DEBUGSTACK-define.patch
Patch12:	ming-0.4.8-12-Fix-CVE-2017-16883.patch
Patch13:	ming-0.4.8-13-Fix-CVE-2017-11732.patch
Patch14:	ming-0.4.8-14-Fix-CVE-2017-16898.patch
Patch15:	ming-0.4.8-15-Fix-CVE-2018-5251.patch
Patch16:	ming-0.4.8-16-Fix-CVE-2018-5294.patch
Patch17:	ming-0.4.8-17-Fix-CVE-2018-6315.patch
Patch18:	ming-0.4.8-18-Fix-CVE-2018-6359.patch
Patch19:	ming-0.4.8-19-Use-OpCode-instead-of-directly-accessing-actions.patch
BuildRequires:	bison
BuildRequires:	chrpath
BuildRequires:	flex
BuildRequires:	libtool
BuildRequires:	giflib-devel
BuildRequires:	perl-devel
BuildRequires:	php-devel
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(python)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(zlib)
# gotta conflict here, otherwise stuff will be linked against installed libs...
BuildConflicts:	ming-devel

%description
Ming is a library for generating SWF ("Flash") format movies. It comprises a
lot of Flash functionality, including features of Flash 8. Specifically, it
lets you create: shapes (including morphs), text, sprites (aka movie clips),
buttons, and actions in flash movies, plus more.

#-----------------------------------------------------------------------------

%package -n %{libname}
Summary:	Ming - an SWF output library
Group:		System/Libraries

%description -n %{libname}
Ming is a library for generating SWF ("Flash") format movies.
This package only contains the basic c-based library.

%files -n %{libname}
%doc LICENSE
%{_libdir}/libming.so.%{major}*

#-----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Ming development files
Group:		Development/C
Requires:	%{libname} = %{EVRD}
Provides:	%{name}-devel = %{EVRD}

%description -n %{devname}
This package contains the development files for %{name}.

%files -n %{devname}
%doc NEWS HISTORY LICENSE README TODO
%{multiarch_bindir}/%{name}-config
%{_bindir}/%{name}-config
%{_libdir}/libming.so
%{_libdir}/pkgconfig/libming.pc
%{_includedir}/%{name}*.h

#-----------------------------------------------------------------------------

%package -n perl-SWF
Summary:	Ming perl extension
Group:		Development/Perl
Provides:	perl-%{name} = %{EVRD}
Requires:	%{libname} = %{EVRD}

%description -n perl-SWF
Ming perl module - perl wrapper for the Ming library.

%files -n perl-SWF
%doc perl_ext.README perl_ext/examples
%dir %{perl_vendorlib}/*/auto/SWF
%dir %{perl_vendorlib}/*/SWF
%{perl_vendorlib}/*/auto/SWF/SWF.so
%{perl_vendorlib}/*/*.pm
%{perl_vendorlib}/*/SWF/*.pm
%{_mandir}/man3*/SWF*

#-----------------------------------------------------------------------------

%package -n python-SWF
Summary:	Ming python extension
Group:		Development/Python
Requires:	%{libname} = %{EVRD}

%description -n python-SWF
Python module - python wrapper for the Ming library.

%files -n python-SWF
%doc py_ext/README
%{py_platsitedir}/*.so
%{py_platsitedir}/*.py*
%{py_platsitedir}/*.egg-info

#-----------------------------------------------------------------------------

%package -n php-SWF
Summary:	Ming php extension
Group:		Development/PHP
Requires:	%{libname} = %{EVRD}
Requires:	php(zend-abi) = %{php_zend_api}
# Php-ming is deprecated and code is merged in the the ming main sources;
# however the %%version of our old package is higher than the one of
# this package, so we cannot simply %%renaming it
Provides:	php-ming = %{EVRD}
Conflicts:	php-ming < %{EVRD}
Obsoletes:	php-ming < %{EVRD}

%description -n php-SWF
Php module - php wrapper for the Ming library.

%files -n php-SWF
%doc php_ext/README.*
%config(noreplace) %{_sysconfdir}/php.d/33_%{name}.ini
%{_libdir}/php/extensions/%{name}.so

#-----------------------------------------------------------------------------

%package utils
Summary:	Ming utilities
Group:		File tools

%description utils
This package contains various ming utilities for working  with .swf files.

%files utils
%doc util.README
%{_bindir}/dbl2png
%{_bindir}/gif2dbl
%{_bindir}/gif2mask
%{_bindir}/listaction
%{_bindir}/listaction_d
%{_bindir}/listfdb
%{_bindir}/listjpeg
%{_bindir}/listmp3
%{_bindir}/listswf
%{_bindir}/listswf_d
%{_bindir}/makefdb
%{_bindir}/makeswf
%{_bindir}/png2dbl
%{_bindir}/raw2adpcm
%{_bindir}/swftocxx
%{_bindir}/swftoperl
%{_bindir}/swftophp
%{_bindir}/swftopython
%{_bindir}/swftotcl
%{_mandir}/man1/dbl2png.1*
%{_mandir}/man1/gif2dbl.1*
%{_mandir}/man1/gif2mask.1*
%{_mandir}/man1/listfdb.1*
%{_mandir}/man1/listjpeg.1*
%{_mandir}/man1/listmp3.1*
%{_mandir}/man1/makefdb.1*
%{_mandir}/man1/makeswf.1*
%{_mandir}/man1/png2dbl.1*
%{_mandir}/man1/raw2adpcm.1*
%{_mandir}/man1/swftocxx.1*
%{_mandir}/man1/swftoperl.1*
%{_mandir}/man1/swftophp.1*
%{_mandir}/man1/swftopython.1*
%{_mandir}/man1/swftotcl.1*

#-----------------------------------------------------------------------------

%prep
%setup -qn %{oname}-%{name}-%{oversion}
%apply_patches

# Fix attribs
find . -type d -perm 0700 -exec chmod 755 {} \;
find . -type f -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0444 -exec chmod 644 {} \;
find . -name "*.c" -o -name "*.h" -exec chmod 644 {} \;
find . -name "*.y" -o -name "*.flex" -exec chmod 644 {} \;

# More cleanup
for i in `find . -type d -name CVS`  `find . -type d -name .svn` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
	if [ -e "$i" ]; then rm -rf $i; fi >&/dev/null
done

# Fix python path
perl -pi -e "s|/usr/local/include\b|%{_includedir}|g;s|/usr/local/lib\b|%{_libdir}|g" py_ext/setup.py.in


%build
autoreconf -vfi
%configure2_5x \
	--enable-shared \
	--disable-static
# Without -j1 the build fails
%make -j1

# We need to build manually python, perl and php extensions,
# otherwise the built files will be installed in wrong places.
# Build the perl extension...
pushd perl_ext
	perl Makefile.PL LIBS="-L%{_libdir} -ljpeg `pkg-config --libs libpng` -lz -lm -lgif" INSTALLDIRS=vendor </dev/null
	make
popd
# ..and the python2 extension
pushd py_ext
	env CFLAGS="%{optflags}" %py_build
popd
# ...and the php extension
pushd php_ext
	./make_module.sh
popd


%install
%makeinstall_std

# Since we built them manually, install manually
# the perl extension...
%makeinstall_std -C perl_ext
# ...and the python2 extension
pushd py_ext
	%py_install
popd
# ...and the php extension
%makeinstall_std -C php_ext
# Taken from our original (deprecated) php-ming package
install -d %{buildroot}%{_sysconfdir}/php.d
cat > %{buildroot}%{_sysconfdir}/php.d/33_%{name}.ini << EOF
extension = %{name}.so
EOF

# Fix docs
cp perl_ext/README perl_ext.README
cp util/README util.README
chmod 644 NEWS HISTORY INSTALL *README* TODO

# Cleanup
rm -rf %{buildroot}%{perl_vendorlib}/*/auto/SWF/include
rm -rf %{buildroot}%{_libdir}/libming.*a

# Nuke rpath
find %{buildroot}%{perl_vendorlib} -name "*.so" | xargs chrpath -d


chmod 755 %{buildroot}%{_bindir}/ming-config
%multiarch_binaries %{buildroot}%{_bindir}/ming-config

# Install man pages
install -d %{buildroot}%{_mandir}/man1
install -m0644 docs/man/*.1 %{buildroot}%{_mandir}/man1/

%changelog

* Wed May 30 2018 Andrey Bondrov <andrey.bondrov@rosalab.ru> 2:0.4.8-2
- (5a1dbdc) Add Epoch to allow proper replacement of php-ming package


